//------------------------------------------------------------------------------
//           Visual Component  TFreePanel ,    TPanel
//
//    WM_NCHITTEST
//     , 
//  design-time
//
//        
//     .
//
//  MinWidth  MinHeight    
//  
//
// !       control-,
//        TFreePanel,   
//           TFreePanel
//
//        ,
//      TFreePanel      
//    ,     .
// ,  TFreePanel   TForm   alTop 
//    TControl    ,    alNone
//     TFreePanel,      
//      
//
// ,1998      , 
//------------------------------------------------------------------------------
unit CapPanel;

interface
Uses extctrls , Messages , WinProcs , Classes , Controls;

Type

   TPanelCaption = class (TPanel)
   private
      FMinWidth ,
      FMinHeight: Integer;
      FMoving   : Boolean;
    procedure SetMoving(const Value: Boolean);
   public
      constructor Create(AOwner : TComponent); override;
      property MinWidth  : Integer read FMinWidth  write FMinWidth;
      property MinHeight : Integer read FMinHeight write FMinHeight;
      property Moving    : Boolean read FMoving    write SetMoving;
   protected
      Procedure WMMyCaption(var Message : TMessage) ; message  WM_NCHITTEST;
      procedure WMGetMinMaxInfo(var Message : TMessage); message WM_GETMINMAXINFO;
   End;

   TFreePanel = class (TPanelCaption)
   published
      property MinWidth;
      property MinHeight;
      property Moving;
   End;

Procedure Register;

implementation
//------------------------------------------------------------------------------
//         Windows
//     ReSize 
//------------------------------------------------------------------------------
Procedure TPanelCaption.WMMyCaption(var Message : TMessage);
Const Delta = 5;
Var X , Y : Integer;
    Point : TPoint;
Begin
  Inherited;

  IF Not (csDesigning IN ComponentState) Then
  Begin
     //    (     )
     Point.x:=Message.LParamLo ;
     Point.y:=Message.LParamHi;

     //        
     Point:= ScreenToClient( Point );

     x:=Point.x;
     y:=Point.y;

     //Message.Result:=HTCLIENT;
     IF FMoving AND (Align = alNone) Then Message.Result:=HTCAPTION;

     //    alClient,   
     IF Align <> alClient Then
     Begin

      //    - ReSize
      IF (( Width - x ) <= Delta) AND ((Height - y ) <= Delta)
                                  AND (Align = alNone)
          Then Begin
                  Message.Result:=HTBOTTOMRIGHT;
                  Exit;
               End;

      //    - ReSize
      IF ( x <= Delta) AND ( y  <= Delta)
                                  AND (Align = alNone)
          Then Begin
                 Message.Result:=HTTOPLEFT;
                 Exit;
               End;

      //    - ReSize
      IF (( Width - x ) <= Delta) AND ( y  <= Delta)
                                  AND (Align = alNone)
          Then Begin
                  Message.Result:=HTTOPRIGHT;
                  Exit;
               End;

      //    - ReSize
      IF ( x <= Delta) AND ( Height - y  <= Delta)
                       AND (Align = alNone)
          Then Begin
                 Message.Result:=HTBOTTOMLEFT;
                 Exit;
               End;

      //   Border
      IF (( Width - x ) <= Delta) AND (Align in [alNone,alLeft])
          Then Message.Result:=HTRIGHT;

      //   Border
      IF (  x  <= Delta) AND (Align in [alNone,alRight])
          Then Message.Result:=HTLEFT;

      //   Border
      IF ((Height - y ) <= Delta) AND (Align in [alNone , alTop])
          Then Message.Result:=HTBOTTOM;

      //   Border
      IF ( y  <= Delta) AND (Align in [alNone , alBottom])
          Then Message.Result:=HTTOP;

     End;

  End;
End;
//------------------------------------------------------------------------------
//          
//------------------------------------------------------------------------------
procedure TPanelCaption.WMGetMinMaxInfo(var Message : TMessage);
type
  PTMinMaxInfo = ^TMinMaxInfo;
begin
  with PTMinMaxInfo(Message.LParam)^.ptMinTrackSize
    do begin
      x := MinWidth;
      y := MinHeight;
    end;
  inherited;
end;
//------------------------------------------------------------------------------
constructor TPanelCaption.Create(AOwner : TComponent);
Begin
  Inherited Create(AOwner);
  FMoving:=False;
End;
//------------------------------------------------------------------------------
procedure Register;
begin
  RegisterComponents('Samples', [TFreePanel]);
end;
//------------------------------------------------------------------------------
procedure TPanelCaption.SetMoving(const Value: Boolean);
begin
  IF Value AND (Align = alNone) Then 
  FMoving := Value;
end;
//------------------------------------------------------------------------------
end.
